:-module(prim_ports,[prim_openPort/3,prim_basicServerLoop/4,prim_sendPort/5,prim_after/4,prim_openProcessPort/2,prim_ping/3,prim_timeoutOnStream/5,prim_openPortOnSocket/3,prim_connectPortAtSocket/4,prim_choiceSPEP/5,checkIncomingPortStreams/3,ifTracePort/1,readPortMessage/4,parse_received_message/4]).
:-style_check(-singleton).
:-current_module(prologbasics)->true;use_module('../prologbasics').
:-current_module(basics)->true;use_module('../basics').
:-current_module(prim_standard)->true;ensure_loaded(user:prim_standard).
:-current_module(prim_readshowterm)->true;use_module(prim_readshowterm).
:-dynamic only_localhost/1,tracePorts/1,mySocket/1,incomingPortStreams/2.
only_localhost(_3220):-(getEnv('PAKCS_LOCALHOST',_3226)->true;_3226=no),(_3226=yes->asserta(only_localhost(yes)),_3220=yes;asserta(only_localhost(no)),_3220=no),retract((only_localhost(_3306):-_3310,_3312)),!.
tracePorts(unknown).
ifTracePort(_3404):-tracePorts(_3408),(_3408=unknown->retract(tracePorts(_3418)),(getEnv('PAKCS_TRACEPORTS',_3428)->true;_3428=no),(_3428=yes->asserta(tracePorts(yes)),_3404;asserta(tracePorts(no)));_3408=yes->_3404;true).
prim_openPort(_3572,_3574,_3576):-nonvar(_3572),!,writeErr('ERROR: openPort: port is not a free variable'),nlErr,fail.
prim_openPort(_3662,_3664,_3666):-nonvar(_3664),!,writeErr('ERROR: openPort: stream is not a free variable'),nlErr,fail.
prim_openPort('Ports.internalPort'([],0,0,_3758),_3758,'Prelude.True').
prim_openPortOnSocket(_3808,_3810,_3812):-(retract(mySocket('Ports.internalPort'(_3816,_3818,_3820,_3822)))->_3840 is _3820+1,asserta(mySocket('Ports.internalPort'(_3816,_3818,_3840,_3822))),(_3808=_3818,_3810=_3840->true;writeErr('ERROR: inconsistent socket/port numbers in openPortOnSocket!'),nlErr);trySetSocketNumber(_3808),on_exception(_3946,listenOnNewSocket(_3808,_3928,_3822),(write('ERROR: openPortOnSocket "'),write(_3808),write('":'),nl,printError(_3946),!,fail)),atom2String(_3928,_3816),(var(_3810)->_3810=0;true),asserta(mySocket('Ports.internalPort'(_3816,_3808,_3810,_3822)))),mySocket(_4070),_4070='Ports.internalPort'(_4074,_4076,_4078,_4080),ifTracePort((writeErr('TRACEPORTS: Listen on port '),writeErr(_4078),writeErr(' at socket '),writeErr(_4076),writeErr(' on host '),(only_localhost(yes)->writeErr(localhost);string2Atom(_4074,_4126),writeErr(_4126)),writeErr(...),nlErr)),(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_4070),_3812);_3812='Ports.basicServerLoop'(_4070)).
trySetSocketNumber(_4306):-var(_4306),getEnv('PAKCS_SOCKET',_4316),atom_codes(_4316,_4322),number_codes(_4306,_4322),!.
trySetSocketNumber(_4390).
prim_basicServerLoop(_4694,_4696,_4698,_4700):-freeze(_4698,blocked_prim_basicServerLoop(_4694,_4696,_4698,_4700)).
blocked_prim_basicServerLoop(_4762,_4764,_4766,_4768):-readPort(_4762,_4774,-1),_4764=[_4774|_4782],(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_4762),_4782);_4782='Ports.basicServerLoop'(_4762)),_4766=_4768.
prim_timeoutOnStream(_5190,_5192,_5194,_5196,_5198):-freeze(_5196,blocked_prim_timeoutOnStream(_5190,_5192,_5194,_5196,_5198)).
blocked_prim_timeoutOnStream(_5268,_5270,_5272,_5274,_5276):-user:derefRoot(_5268,_5282),prim_timeoutOnStream_exec(_5282,_5270,_5272,_5274,_5276).
prim_timeoutOnStream_exec(_5376,_5378,'Prelude.Nothing',_5382,_5384):-var(_5378),!,_5382=_5384.
prim_timeoutOnStream_exec(_5480,share(_5476),_5484,_5486,_5488):-!,get_mutable(_5492,_5476),(_5492='$eval'(_5498)->_5484=_5498,_5486=_5488;prim_timeoutOnStream_exec(_5480,_5492,_5536,_5486,_5488),(_5536='Prelude.Nothing'->_5484=_5536;(compileWithSharing(variable)->user:propagateShare(_5536,_5484);_5536=_5484),update_mutable('$eval'(_5484),_5476))).
prim_timeoutOnStream_exec(_5712,[],'Prelude.Just'([]),_5718,_5720):-!,_5718=_5720.
prim_timeoutOnStream_exec(_5818,[_5802|_5804],'Prelude.Just'([_5802|_5804]),_5824,_5826):-!,_5824=_5826.
prim_timeoutOnStream_exec(_5912,'Ports.basicServerLoop'(_5908),_5916,_5918,_5920):-(readPort(_5908,_5926,_5912)->(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_5908),_5942);_5942='Ports.basicServerLoop'(_5908)),_5916='Prelude.Just'([_5926|_5942]);_5916='Prelude.Nothing'),_5918=_5920.
send_extvar_binding(_6358,_6360,_6362,_6364):-freeze(_6360,blocked_send_extvar_binding(_6358,_6360,_6362,_6364)).
blocked_send_extvar_binding(_6426,_6428,_6430,_6432):-evalToken(_6436),user:normalizeAndCheck(_6428,_6442,_6436,_6446),user:waitUntilGround(_6442,_6446,_6460),eval_send_extvar_binding(_6426,_6442,_6430,_6460,_6432).
eval_send_extvar_binding(_6862,_6864,_6866,_6868,_6870):-freeze(_6868,blocked_eval_send_extvar_binding(_6862,_6864,_6866,_6868,_6870)).
blocked_eval_send_extvar_binding(nostream,_6942,_6944,_6946,_6948):-writeErr('ERROR: cannot send binding for variable '),writeErr(_6944),writeErr(': '),writeErr(_6942),nlErr,!.
blocked_eval_send_extvar_binding(_7064,_7066,_7068,_7070,_7072):-show4sending(_7066,_7078,_7080),ifTracePort((writeErr('TRACEPORTS: send binding for variable '),writeErr(_7068),writeErr(': '),writeChars(user_error,_7078),nlErr)),number_codes(_7068,_7132),putChars(_7064,[86|_7132]),put_code(_7064,10),writeChars(_7064,_7078),put_code(_7064,10),flush_output(_7064),!,_7072=done.
readPort('Ports.internalPort'(_7296,_7298,_7300,_7302),_7308,_7310):-var(_7302),!,string2Atom(_7296,_7320),writeErr('ERROR: readPort: Port '),writeErr(_7298),writeErr(/),writeErr(_7300),writeErr(@),writeErr(_7320),writeErr(' only opened for writing!'),nlErr.
readPort('Ports.internalPort'(_7462,_7464,_7466,_7468),_7474,_7476):-on_exception(_7490,readFromSocket(_7466,_7468,_7474,_7476),(printError(_7490)->_7474=[];_7474=[])),!.
checkIncomingPortStreams(_7582,_7584,_7586):-retract(incomingPortStreams(_7582,[message(_7584,_7586)|_7598])),asserta(incomingPortStreams(_7582,_7598)),!.
checkIncomingPortStreams(_7684,_7686,_7688):-retract(incomingPortStreams(_7684,[ping(_7692,_7694)|_7700])),asserta(incomingPortStreams(_7684,_7700)),answerPingOnStream(_7692,_7694),checkIncomingPortStreams(_7684,_7686,_7688),!.
answerPingOnStream(_7812,_7814):-write(_7814,ok),put_code(_7814,10),flush_output(_7814),closeSocketStream(_7812,_7814),ifTracePort((writeErr('TRACEPORTS: Ping request answered.'),nlErr)).
readFromSocket(_7920,_7922,_7924,_7926):-checkIncomingPortStreams(_7920,_7932,_7934),!,readStreamLine(_7932,_7940),(parse_received_message(_7932,_7934,_7940,_7924)->ifTracePort((writeErr('TRACEPORTS: Received message: '),putChars(user_error,_7940),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_7940),nlErr,readFromSocket(_7920,_7922,_7924,_7926)),!.
readFromSocket(_8112,_8114,_8116,_8118):-waitForSocketClientStream(_8114,_8118,_8126,_8128,_8130),ifTracePort((writeErr('TRACEPORTS: Connection to client: '),writeErr(_8126),nlErr)),(readPortMessage(_8112,_8128,_8130,_8164)->(parse_received_message(_8128,_8130,_8164,_8116)->ifTracePort((writeErr('TRACEPORTS: Received message: '),putChars(user_error,_8164),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_8164),nlErr,readFromSocket(_8112,_8114,_8116,_8118));readFromSocket(_8112,_8114,_8116,_8118)),!.
readFromSocket(_8352,_8354,_8356,_8358):-ifTracePort((writeErr('TRACEPORTS: Timeout!'),nlErr)),fail.
readPortMessage(_8440,_8442,_8444,_8446):-readStreamLine(_8442,_8452),_8452=[_8456|_8458],checkMessageHeader(_8456,_8442,_8444,_8474),number_codes(_8478,_8458),!,(_8478=_8440->readPortMessageBody(_8474,_8446);(retract(incomingPortStreams(_8478,_8504))->append(_8504,[_8474],_8522);_8522=[_8474]),asserta(incomingPortStreams(_8478,_8522)),!,fail).
checkMessageHeader(78,_8672,_8674,message(_8672,_8674)):-!.
checkMessageHeader(80,_8746,_8748,ping(_8746,_8748)):-!.
checkMessageHeader(_8820,_8822,_8824,_8826):-writeErr('ERROR: Illegal message header received.'),nlErr,!,fail.
readPortMessageBody(message(_8910,_8912),_8918):-readStreamLine(_8910,_8918).
readPortMessageBody(ping(_8970,_8972),_8978):-answerPingOnStream(_8970,_8972),!,fail.
prim_sendPort(_9280,_9282,_9284,_9286,_9288):-freeze(_9286,blocked_prim_sendPort(_9280,_9282,_9284,_9286,_9288)).
blocked_prim_sendPort(_9358,_9360,_9362,_9364,_9366):-user:derefAll(_9358,_9372),user:derefRoot(_9360,_9384),prim_sendPortExec(_9372,_9384,_9362,_9364,_9366).
prim_sendPortExec(_9494,'Ports.internalPort'(_9484,0,_9488,_9490),'Prelude.True',_9500,_9502):-!,add2Stream(_9490,_9494),_9500=_9502.
prim_sendPortExec('Ports.SP_Put'(_9596),'Ports.internalPort'(_9600,-1,_9604,_9606),'Prelude.True',_9616,_9618):-!,user:waitUntilGround(_9596,_9616,_9618),writeChars(_9606,_9596),nl(_9606),flush_output(_9606),ifTracePort((writeErr('TRACEPORTS: SP_Put: '),writeChars(user_error,_9596),nlErr)).
prim_sendPortExec('Ports.SP_GetLine'(_9772),'Ports.internalPort'(_9776,-1,_9780,_9782),'Prelude.True',_9792,_9794):-!,readStreamLine(_9776,_9800),map2M(basics:char_int,_9812,_9800),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_9812),nlErr)),user:constrEq(_9812,_9772,_9848,_9792,_9794).
prim_sendPortExec('Ports.SP_GetChar'(_9952),'Ports.internalPort'(_9956,-1,_9960,_9962),'Prelude.True',_9972,_9974):-!,get_code(_9956,_9980),char_int(_9980,_9986),ifTracePort((writeErr('TRACEPORTS: SP_GetChar: '),writeErr(_9986),nlErr)),user:constrEq(_9986,_9952,_10018,_9972,_9974).
prim_sendPortExec('Ports.SP_EOF'(_10122),'Ports.internalPort'(_10126,-1,_10130,_10132),'Prelude.True',_10142,_10144):-!,(atEndOfStream(_10126)->_10152='Prelude.True';_10152='Prelude.False'),ifTracePort((writeErr('TRACEPORTS: SP_EOF: '),writeErr(_10152),nlErr)),user:constrEq(_10122,_10152,_10204,_10142,_10144).
prim_sendPortExec('Ports.SP_Close','Ports.internalPort'(_10302,-1,_10306,_10308),'Prelude.True',_10318,_10320):-!,close(_10308),close(_10302),_10318=_10320.
prim_sendPortExec(_10432,'Ports.internalPort'(_10422,-1,_10426,_10428),'Prelude.True',_10438,_10440):-!,writeErr('ERROR: wrong message received by stream port: '),writeErr(_10432),nlErr,_10438=_10440.
prim_sendPortExec(_10558,'Ports.internalPort'(_10548,_10550,_10552,_10554),'Prelude.True',_10564,_10566):-string2Atom(_10548,_10572),on_exception(_10606,send2Socket(_10572,_10550,_10552,_10558),(write('ERROR: send to port '),write(_10552),write(@),write(_10572),write(:),nl,(printError(_10606)->true;true))),_10564=_10566.
add2Stream(_10750,_10752):-var(_10750),!,_10750=[_10752|_10762].
add2Stream([],_10828):-write('ERROR: send: stream has not a free variable at the end'),nl.
add2Stream([_10884|_10886],_10892):-add2Stream(_10886,_10892).
prim_ping(_10958,'Ports.internalPort'(_10944,0,_10948,_10950),'Prelude.Just'(0)):-!.
prim_ping(_11030,'Ports.internalPort'(_11016,-1,_11020,_11022),'Prelude.Just'(0)):-!.
prim_ping(_11098,'Ports.internalPort'(_11088,_11090,_11092,_11094),_11102):-string2Atom(_11088,_11108),on_exception(_11130,ping2SocketPort(_11108,_11090,_11092,_11098,_11102),_11102='Prelude.Nothing').
ping2SocketPort(_11194,_11196,_11198,_11200,_11202):-connect2socket(_11194,_11196,_11210,_11212),number_codes(_11198,_11218),putChars(_11212,[80|_11218]),put_code(_11212,10),flush_output(_11212),getElapsedTime(_11244),ifTracePort((writeErr('TRACEPORTS: Ping to "'),writeErr(_11196),writeErr(/),writeErr(_11198),writeErr(@),writeErr(_11194),writeErr('"'),nlErr)),waitForInputDataOnStreams([_11210],_11200,_11332),(_11332=0->readStreamLine(_11210,_11344),closeSocketStream(_11210,_11212),getElapsedTime(_11354),_11364 is _11354-_11244,ifTracePort((writeErr('TRACEPORTS: Ping answer received in '),writeErr(_11364),writeErr(' ms'),nlErr)),_11202='Prelude.Just'(_11364);ifTracePort((writeErr('TRACEPORTS: No ping answer received'),nlErr)),_11202='Prelude.Nothing').
prim_connectPortAtSocket(_11606,_11608,_11610,'Ports.internalPort'(_11596,_11598,_11600,'Prelude.()')):-user:derefRoot(_11606,_11598),user:derefRoot(_11608,_11600),user:derefAll(_11610,_11596),!.
send2Socket(_11728,_11730,_11732,_11734):-connect2socket(_11728,_11730,_11742,_11744),number_codes(_11732,_11750),putChars(_11744,[78|_11750]),put_code(_11744,10),show4sending(_11734,_11774,_11776),writeChars(_11744,_11774),put_code(_11744,10),flush_output(_11744),ifTracePort((writeErr('TRACEPORTS: Sent to "'),writeErr(_11730),writeErr(/),writeErr(_11732),writeErr(@),writeErr(_11728),writeErr('": '),writeChars(user_error,_11774),nlErr)),rev(_11776,_11884),receive_extvar_bindings(_11742,_11884).
receive_extvar_bindings(_12012,[]):-!,ifTracePort((writeErr('TRACEPORTS: Closing send-connection'),nlErr)),close(_12012).
receive_extvar_bindings(_12090,_12092):-readStreamLine(_12090,_12098),_12098=[86|_12104],number_codes(_12114,_12104),readStreamLine(_12090,_12122),(deleteIndexVariable(_12114,_12092,_12130,_12132)->true;writeErr('ERROR: Illegal binding for logical variable received:'),nlErr,_12132=_12092),(parse_received_message(nostream,nostream,_12122,_12176)->ifTracePort((writeErr('TRACEPORTS: Received binding for variable '),writeErr(_12114),writeErr(': '),putChars(user_error,_12122),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_12122),nlErr),!,_12130=_12176,receive_extvar_bindings(_12090,_12132).
show4sending(_12362,_12364,_12366):-numberVars(_12362,_12372,[],_12366),show_term(_12372,qualified,_12364,[]).
getVariableIndex(_12458,[(_12446,_12448)|_12454],_12448):-_12458==_12446,!.
getVariableIndex(_12534,[_12528|_12530],_12538):-getVariableIndex(_12534,_12530,_12538).
getIndexVariable(_12602,[(_12600,_12602)|_12608],_12600):-!.
getIndexVariable(_12676,[_12670|_12672],_12680):-getIndexVariable(_12676,_12672,_12680).
deleteIndexVariable(_12744,[(_12742,_12744)|_12750],_12742,_12750):-!.
deleteIndexVariable(_12834,[_12822|_12824],_12838,[_12822|_12830]):-deleteIndexVariable(_12834,_12824,_12838,_12830).
parse_received_message(_12912,_12914,_12916,_12918):-readTerm(_12916,qualified,_12926,_12928),skipWhiteSpace(_12926,[]),extractVars(_12928,_12918,[],_12944),send_extvar_bindings(_12944,_12950,_12914),closeStreamAfterDones(_12950,_12912,_12914).
send_extvar_bindings([],[],_13050).
send_extvar_bindings([(_13092,_13094)|_13100],[_13104|_13106],_13114):-send_extvar_binding(_13114,_13092,_13094,_13104),send_extvar_bindings(_13100,_13106,_13114).
closeStreamAfterDones([],nostream,_13196):-!.
closeStreamAfterDones([],_13252,_13254):-ifTracePort((writeErr('TRACEPORTS: Closing receive-connection'),nlErr)),closeSocketStream(_13252,_13254).
closeStreamAfterDones([_13334|_13336],_13342,_13344):-closeStreamAfterDones(_13334,_13336,_13342,_13344).
closeStreamAfterDones(_13692,_13694,_13696,_13698):-freeze(_13692,blocked_closeStreamAfterDones(_13692,_13694,_13696,_13698)).
blocked_closeStreamAfterDones(_13760,_13762,_13764,_13766):-closeStreamAfterDones(_13762,_13764,_13766).
prim_openProcessPort(_13846,'Ports.internalPort'(_13836,-1,0,_13842)):-user:derefAll(_13846,_13854),string2Atom(_13854,_13866),execCommand(_13866,_13842,_13836,_13876).
prim_choiceSPEP(_14226,_14228,_14230,_14232,_14234):-freeze(_14228,freeze(_14232,blocked_prim_choiceSPEP(_14226,_14228,_14230,_14232,_14234))).
blocked_prim_choiceSPEP(_14310,_14312,_14314,_14316,_14318):-user:derefRoot(_14310,_14324),prim_choiceSPEP_exec(_14324,_14312,_14314,_14316,_14318).
prim_choiceSPEP_exec(_14422,share(_14418),_14426,_14428,_14430):-!,get_mutable(_14434,_14418),(_14434='$eval'(_14440)->_14428=_14430,_14426='Prelude.Right'(_14440);prim_choiceSPEP_exec(_14422,_14434,_14482,_14428,_14430),(_14482='Prelude.Left'(_14490)->_14426=_14482;_14482='Prelude.Right'(_14512),(compileWithSharing(variable)->user:propagateShare(_14512,_14528);_14512=_14528),_14426='Prelude.Right'(_14528),update_mutable('$eval'(_14528),_14418))).
prim_choiceSPEP_exec(_14706,[_14690|_14692],'Prelude.Right'([_14690|_14692]),_14712,_14714):-!,_14712=_14714.
prim_choiceSPEP_exec('Ports.internalPort'(_14796,-1,_14800,_14802),[],_14810,_14812,_14814):-readStreamLine(_14796,_14820),map2M(basics:char_int,_14832,_14820),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_14832),nlErr)),_14810='Prelude.Left'(_14832),_14812=_14814,!.
prim_choiceSPEP_exec(_14980,'Ports.basicServerLoop'(_14976),_14984,_14986,_14988):-_14976='Ports.internalPort'(_14992,_14994,_14996,_14998),checkIncomingPortStreams(_14996,_15010,_15012),!,readStreamLine(_15010,_15018),(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_14976),_15032);_15032='Ports.basicServerLoop'(_14976)),(parse_received_message(_15010,_15012,_15018,_15064)->ifTracePort((writeErr('TRACEPORTS: Received message: '),writeErr(_15064),nlErr)),_14984='Prelude.Right'([_15064|_15032]);writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_15018),nlErr,prim_choiceSPEP_exec(_14980,_15032,_14984,_14986,_14988)),_14986=_14988,!.
prim_choiceSPEP_exec('Ports.internalPort'(_15280,-1,_15284,_15286),'Ports.basicServerLoop'(_15290),_15298,_15300,_15302):-_15290='Ports.internalPort'(_15306,_15308,_15310,_15312),waitForSocketOrInputStreams(_15312,_15330,_15332,_15334,[_15280],_15338),(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_15290),_15352);_15352='Ports.basicServerLoop'(_15290)),(_15330=no->readStreamLine(_15280,_15386),map2M(basics:char_int,_15398,_15386),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_15398),nlErr)),_15298='Prelude.Left'(_15398);ifTracePort((writeErr('TRACEPORTS: Connection to client: '),writeErr(_15330),nlErr)),(readPortMessage(_15310,_15332,_15334,_15494)->(parse_received_message(_15332,_15334,_15494,_15504)->ifTracePort((writeErr('TRACEPORTS: Received message: '),writeErr(_15504),nlErr)),_15298='Prelude.Right'([_15504|_15352]);writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_15494),nlErr,prim_choiceSPEP_exec('Ports.internalPort'(_15280,-1,_15574,_15286),_15352,_15298,_15300,_15302));prim_choiceSPEP_exec('Ports.internalPort'(_15280,-1,_15626,_15286),_15352,_15298,_15300,_15302))),_15300=_15302,!.
numberVars(_15768,'VAR'(_15764),_15772,_15774):-var(_15768),!,(getVariableIndex(_15768,_15772,_15764)->_15774=_15772;length(_15772,_15764),_15774=[(_15768,_15764)|_15772]).
numberVars(_15908,_15910,_15912,_15914):-isShowableArg(_15908),_15908=..[_15922|_15924],numberVarsList(_15924,_15936,_15912,_15914),_15910=..[_15922|_15936].
numberVarsList([],[],_16036,_16036).
numberVarsList([_16088|_16090],[_16094|_16096],_16104,_16106):-numberVars(_16088,_16094,_16104,_16116),numberVarsList(_16090,_16096,_16116,_16106).
extractVars(_16194,_16194,_16198,_16198):-var(_16194),!.
extractVars('VAR'(_16272),_16278,_16280,_16282):-!,(getIndexVariable(_16272,_16280,_16278)->_16282=_16280;_16282=[(_16278,_16272)|_16280]).
extractVars(_16394,_16396,_16398,_16400):-_16394=..[_16404|_16406],extractVarsList(_16406,_16418,_16398,_16400),_16396=..[_16404|_16418].
extractVarsList([],[],_16512,_16512).
extractVarsList([_16564|_16566],[_16570|_16572],_16580,_16582):-extractVars(_16564,_16570,_16580,_16592),extractVarsList(_16566,_16572,_16592,_16582).
prim_after(_16888,_16890,_16892,_16894):-freeze(_16892,blocked_prim_after(_16888,_16890,_16892,_16894)).
blocked_prim_after(_16956,_16958,_16960,_16960):-raise_exception('Ports.after not implemented!').
